local Zifnabs_release="r131003a" 
local Zifnabs_DefaultSettings = {
		["point"] = "CENTER",
		["relativePoint"] = "CENTER",
		["relativeTo"] = "UIParent",
		["offsetX"] = -400,
		["offsetY"] = 75,
		["visible"] = 1,
		["reloadui"] = 1,
		["button"]={[1]="hi",[2]="bye"},
		["say"]={
			["hi"] = {
				["notarget"]={"Hallo zusammen","Seid mir gegrüßt, alle zusammen"},
				["any"]={"Hallo, %t","Sei mir gegrüßt, %t"},
				["male"]={"Schön, Dich zu sehen, %t"},
				["female"]={"Wie schön, Dich zu sehen, %t", "Sei mir gegrüßt, holde %t"},
			},
			["bye"]={
				["notarget"]={"Ciao","Auf Wiedersehen","Lebt wohl alle miteinander"},
				["any"]={"Auf Wiedersehen, %t","Lebewohl, %t", "Gute Wege, %t"},
				["male"]={"Mach's gut, %t"},
				["female"]={},
			},
		},
}

local say = {}

function Zifnabs_OnLoad(this)
	zif_echo(Zifnabs_release.." wird geladen")
	this:RegisterEvent("SAVE_VARIABLES")
	this:RegisterEvent("VARIABLES_LOADED")
	this:RegisterEvent("UNIT_TARGET_CHANGED")
	this:RegisterEvent("COMBATMETER_DAMAGE")
	this:RegisterEvent("LOADING_END")

	SaveVariables("Zifnabs_Settings")  -- settings are saved to this table
--	zif_display()
end

SLASH_Zifnabs1="/zif"
SlashCmdList["Zifnabs"]=function(editBox,command)
	local word1,parm=zif_parse(command)
	word1=string.lower(word1)
	local word2,parm2=zif_parse(parm)
	word2=string.lower(word2)
	if (word1=="hide" and parm=="") then	
		Zifnabs_Settings.visible=0
		zif_display()
		zif_echo("wird nicht mehr angezeigt")
	elseif (word1=="show" and parm=="") then
		Zifnabs_Settings.visible=1
		zif_display()
		zif_echo("wird angezeigt")
	elseif (word1=="hide" and string.lower(parm)=="rui") then
		Zifnabs_Settings.reloadui=0
		getglobal("Zifnabs_ReloadUI"):Hide()
		zif_echo("ReloadUI-Button wird nicht mehr angezeigt")
	elseif (word1=="show" and  string.lower(parm)=="rui") then
		Zifnabs_Settings.reloadui=1
		getglobal("Zifnabs_ReloadUI"):Show()
		zif_echo("ReloadUI-Button wird angezeigt")
	elseif (say[word1] and parm=="") then
		zif_tell(word1)
	elseif (say[word1] and word2=="list") then
		zif_echo("Liste für '"..word1.."'")
		for category,table in pairs(say[word1]) do
			zif_echo(category..":")
			for t=1,#table,1 do
				zif_echo(t..": "..table[t])
			end
		end
	elseif (say[word1] and word2=="add") then
		zif_error("add noch nicht implementiert")
	elseif (say[word1] and word2=="del") then
		if parm2=="" then
--			for nr,text in pairs(Zifnab_Settings["button"]) do
--				if text==word1 then
--					table.remove(Zifnabs_Settings["button"],nr)
--				end
--			end
--			table.remove(say,word1)
			zif_echo("Kategorie "..word1.." gelöscht")
			zif_display()
		else
			local target,number=zif_parse(parm2)
			zif_error("Löschen eines Textes "..number.." aus der Gruppe "..target.." noch nicht implementiert")
		end
	elseif (word2=="define") then
		if say[word1] then
			zif_error("Kategorie "..word1.." ist bereits definiert")
		else
			local newcategory={["notarget"]={},["any"]={},["female"]={},["male"]={}}
			table.insert(say,word1)
			say[word1]=newcategory
			Zifnabs_Settings["say"]=say
			local bnr=0
			for i=1,99,1 do
				if bnr==0 and not Zifnabs_Settings["button"][i] then
					bnr=i
				end
			end
			table.insert(Zifnabs_Settings["button"],bnr,word1)
			zif_echo("Neue Kategorie "..word1.." erstellt")
			zif_display()
		end
	end	
end

function Zifnabs_OnEvent(this, event)

	if ( event == "UNIT_TARGET_CHANGED" ) then
	elseif ( event == "COMBATMETER_DAMAGE" ) then
	elseif ( event == "LOADING_END" ) then
		zif_display()
		zif_echo("ist geladen")
	elseif ( event == "SAVE_VARIABLES" ) then
		local point, relativePoint, relativeTo, x, y = this:GetAnchor()
		assert(Zifnabs_Settings, "[Zifnabs:SAVE_VARIABLES] Zifnabs_Settings variable is nil!" )
		Zifnabs_Settings.point = point
		Zifnabs_Settings.relativePoint = relativePoint
		Zifnabs_Settings.relativeTo = relativeTo:GetName()
		Zifnabs_Settings.offsetX = x
		Zifnabs_Settings.offsetY = y
		zif_echo("Einstellungen gespeichert")

	elseif ( event == "VARIABLES_LOADED" ) then
		if not Zifnabs_Settings then
			Zifnabs_Settings={}
			Zifnabs_Settings=Zifnabs_DefaultSettings
			zif_echo("Default-Einstellungen geladen")
		else
			for item,value in pairs(Zifnabs_DefaultSettings) do
				if not Zifnabs_Settings[item] then
					zif_echo("Neue Einstellung "..item.." eingefügt")
					Zifnabs_Settings[item]=Zifnabs_DefaultSettings[item]
				end
			end

		end
		
		this:ClearAllAnchors()
		this:SetAnchor(Zifnabs_Settings.point, Zifnabs_Settings.relativePoint, Zifnabs_Settings.relativeTo, Zifnabs_Settings.offsetX, Zifnabs_Settings.offsetY)
	else
		zif_error("undefinierter Event "..event..", arg1="..arg1)
	end	
end

function zif_display()
	say=Zifnabs_Settings["say"]
	getglobal("Zifnabs_Title"):SetText("Zifnabs "..Zifnabs_release)
	for number,text in pairs(Zifnabs_Settings["button"]) do
		if getglobal("Zifnabs_Button"..number) then
			getglobal("Zifnabs_Button"..number):Show()
			getglobal("Zifnabs_Button"..number):SetText(text)
		else
			zif_echo("Button "..number.." für "..text.." nicht gefunden")
		end
	end
	Zifnabs_Settings["release"]=Zifnabs_release
	if (Zifnabs_Settings["reloadui"]==1) then
		getglobal("Zifnabs_ReloadUI"):Show()
	else
		getglobal("Zifnabs_ReloadUI"):Hide()
	end
	if Zifnabs_Settings["visible"]==1 then
		getglobal("Zifnabs"):Show()
	else
		getglobal("Zifnabs"):Hide()
	end
end

function zif_parse(text)
	local blank=string.find(text," ")
	local parm=""
	if blank then
		parm=string.sub(text,blank+1)
		text=string.lower(string.sub(text,1,blank-1))
	end
	return text,parm
end

function zif_echo(text)
	DEFAULT_CHAT_FRAME:AddMessage("|cffe0a000Zifnabs: |r"..text)
end
function zif_error(text)
	DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Zifnabs: "..text.."|r")
end

function zif_button(number)
	zif_tell(Zifnabs_Settings["button"][number])
end

function zif_tell(mode)
	local tbl1={}
	local tbl2={}
	local message=""
	if (UnitExists("target")) then
		tbl1=say[mode]["any"]
		if UnitIsPlayer("target") and UnitSex("target")==0 then
			tbl2=say[mode]["male"]
		elseif UnitIsPlayer("target") and UnitSex("target")==1 then
			tbl2=say[mode]["female"]
		end
	else
		tbl1=say[mode]["notarget"]
	end
	local mi=math.random(#tbl1+#tbl2)
	if mi<=#tbl1 then
		message=tbl1[mi]
	else
		message=tbl2[mi-#tbl1]
	end
	if message then
		SendChatMessage(message, "SAY", 0);
	else
		zif_error("interner Fehler, keine Meldung generiert")
	end
end
